/* A Bison parser, made from parser.yy
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	DEFINE	257
# define	DOMAIN_TOKEN	258
# define	PROBLEM	259
# define	REQUIREMENTS	260
# define	TYPES	261
# define	CONSTANTS	262
# define	PREDICATES	263
# define	FUNCTIONS	264
# define	STRIPS	265
# define	TYPING	266
# define	NEGATIVE_PRECONDITIONS	267
# define	DISJUNCTIVE_PRECONDITIONS	268
# define	EQUALITY	269
# define	EXISTENTIAL_PRECONDITIONS	270
# define	UNIVERSAL_PRECONDITIONS	271
# define	QUANTIFIED_PRECONDITIONS	272
# define	CONDITIONAL_EFFECTS	273
# define	FLUENTS	274
# define	ADL	275
# define	DURATIVE_ACTIONS	276
# define	DURATION_INEQUALITIES	277
# define	CONTINUOUS_EFFECTS	278
# define	PROBABILISTIC_EFFECTS	279
# define	REWARDS	280
# define	MDP	281
# define	DELAYED_ACTIONS	282
# define	EXOGENOUS_EVENTS	283
# define	GSMDP	284
# define	ACTION	285
# define	DELAYED_ACTION	286
# define	DELAYED_EVENT	287
# define	PARAMETERS	288
# define	PRECONDITION	289
# define	CONDITION	290
# define	DELAY	291
# define	EFFECT	292
# define	PDOMAIN	293
# define	OBJECTS	294
# define	INIT	295
# define	REWARD_RATE	296
# define	GOAL	297
# define	GOAL_REWARD	298
# define	METRIC	299
# define	TOTAL_TIME	300
# define	GOAL_ACHIEVED	301
# define	EXPONENTIAL	302
# define	WEIBULL	303
# define	LOGNORMAL	304
# define	UNIFORM	305
# define	WHEN	306
# define	NOT	307
# define	AND	308
# define	OR	309
# define	IMPLY	310
# define	EXISTS	311
# define	FORALL	312
# define	PROBABILISTIC	313
# define	ASSIGN	314
# define	SCALE_UP	315
# define	SCALE_DOWN	316
# define	INCREASE	317
# define	DECREASE	318
# define	MINIMIZE	319
# define	MAXIMIZE	320
# define	NUMBER_TOKEN	321
# define	OBJECT_TOKEN	322
# define	EITHER	323
# define	LE	324
# define	GE	325
# define	NAME	326
# define	VARIABLE	327
# define	NUMBER	328
# define	ILLEGAL_TOKEN	329

#line 26 "parser.yy"

#include <config.h>
#include "problems.h"
#include "domains.h"
#include "events.h"
#include "effects.h"
#include "formulas.h"
#include "expressions.h"
#include "distributions.h"
#include "functions.h"
#include "predicates.h"
#include "terms.h"
#include "types.h"
#include "rational.h"
#include <iostream>
#include <map>
#include <string>
#include <stdexcept>
#include <typeinfo>


/* Workaround for bug in Bison 1.35 that disables stack growth. */
#define YYLTYPE_IS_TRIVIAL 1


/*
 * Context of free variables.
 */
struct Context {
  void push_frame() {
    frames_.push_back(VariableMap());
  }

  void pop_frame() {
    frames_.pop_back();
  }

  void insert(const std::string& name, const Variable& v) {
    frames_.back().insert(std::make_pair(name, v));
  }

  const Variable* shallow_find(const std::string& name) const {
    VariableMap::const_iterator vi = frames_.back().find(name);
    if (vi != frames_.back().end()) {
      return &(*vi).second;
    } else {
      return 0;
    }
  }

  const Variable* find(const std::string& name) const {
    for (std::vector<VariableMap>::const_reverse_iterator fi =
	   frames_.rbegin(); fi != frames_.rend(); fi++) {
      VariableMap::const_iterator vi = (*fi).find(name);
      if (vi != (*fi).end()) {
	return &(*vi).second;
      }
    }
    return 0;
  }

private:
  struct VariableMap : public std::map<std::string, Variable> {
  };

  std::vector<VariableMap> frames_;
};


/*
 * PDDL requirements.
 */
struct Requirements {
  /* Required action style. */
  bool strips;
  /* Whether support for types is required. */
  bool typing;
  /* Whether support for negative preconditions is required. */
  bool negative_preconditions;
  /* Whether support for disjunctive preconditions is required. */
  bool disjunctive_preconditions;
  /* Whether support for equality predicate is required. */
  bool equality;
  /* Whether support for existentially quantified preconditions is
     required. */
  bool existential_preconditions;
  /* Whether support for universally quantified preconditions is
     required. */
  bool universal_preconditions;
  /* Whether support for conditional effects is required. */
  bool conditional_effects;
  /* Whether support for fluents is required. */
  bool fluents;
  /* Whether support for probabilistic effects is required. */
  bool probabilistic_effects;
  /* Whether support for rewards is required. */
  bool rewards;
  /* Whether support for delayed actions is required. */
  bool delayed_actions;
  /* Whether support for exogenous events is required. */
  bool exogenous_events;

  /* Constructs a default requirements object. */
  Requirements()
    : strips(true), typing(false), negative_preconditions(false),
      disjunctive_preconditions(false), equality(false),
      existential_preconditions(false), universal_preconditions(false),
      conditional_effects(false), fluents(false), probabilistic_effects(false),
      rewards(false), delayed_actions(false), exogenous_events(false) {}

  /* Enables quantified preconditions. */
  void quantified_preconditions() {
    existential_preconditions = true;
    universal_preconditions = true;
  }

  /* Enables ADL style actions. */
  void adl() {
    strips = true;
    typing = true;
    negative_preconditions = true;
    disjunctive_preconditions = true;
    equality = true;
    quantified_preconditions();
    conditional_effects = true;
  }

  /* Enables MDP planning problems. */
  void mdp() {
    probabilistic_effects = true;
    rewards = true;
  }

  /* Enables GSMDP planning problems. */
  void gsmdp() {
    mdp();
    delayed_actions = true;
    exogenous_events = true;
  }
};


/* The lexer. */
extern int yylex();
/* Current line number. */
extern size_t line_number;
/* Name of current file. */
extern std::string current_file;
/* Level of warnings. */
extern int warning_level;

/* Whether the last parsing attempt succeeded. */
static bool success = true;
/* Current domain. */
static Domain* domain;
/* Domains and their requirements. */
static std::map<std::string, std::pair<Domain*, Requirements> > domains;
/* Pointer to problem being parsed, or 0 if no problem is being parsed. */
static Problem* problem;
/* Current requirements. */
static Requirements* requirements;
/* The reward function, if rewards are required. */
static Function reward_function(-1);
/* Predicate being parsed. */
static const Predicate* predicate;
/* Whether predicate declaration is repeated. */
static bool repeated_predicate;
/* Function being parsed. */
static const Function* function;
/* Whether function declaration is repeated. */
static bool repeated_function;
/* Pointer to event being parsed, or 0 if no event is being parsed. */
static EventSchema* event;
/* Current variable context. */
static Context context;
/* Predicate for atomic state formula being parsed. */
static const Predicate* atom_predicate;
/* Whether the predicate of the currently parsed atom was undeclared. */
static bool undeclared_atom_predicate;
/* Whether parsing effect fluents. */
static bool effect_fluent;
/* Whether parsing metric fluent. */
static bool metric_fluent;
/* Function for fluent being parsed. */
static const Function* fluent_function;
/* Whether the function of the currently parsed fluent was undeclared. */
static bool undeclared_fluent_function;
/* Paramerers for atomic state formula or fluent being parsed. */
static TermList term_parameters;
/* Quantified variables for effect or formula being parsed. */
static TermList quantified;
/* Most recently parsed term for equality formula. */
static Term eq_term(0);
/* Most recently parsed expression for equality formula. */
static const Expression* eq_expr;
/* The first term for equality formula. */
static Term first_eq_term(0);
/* The first expression for equality formula. */
static const Expression* first_eq_expr;
/* Kind of name map being parsed. */
static enum { TYPE_KIND, CONSTANT_KIND, OBJECT_KIND, VOID_KIND } name_kind;

/* Outputs an error message. */
static void yyerror(const std::string& s); 
/* Outputs a warning message. */
static void yywarning(const std::string& s);
/* Creates an empty domain with the given name. */
static void make_domain(const std::string* name);
/* Creates an empty problem with the given name. */
static void make_problem(const std::string* name,
			 const std::string* domain_name);
/* Adds :typing to the requirements. */
static void require_typing();
/* Adds :delayed-actions to the requirements. */
static void require_delayed_actions();
/* Adds :exogenous-events to the requirements. */
static void require_exogenous_events();
/* Adds :fluents to the requirements. */
static void require_fluents();
/* Adds :disjunctive-preconditions to the requirements. */
static void require_disjunction();
/* Adds :conditional-effects to the requirements. */ 
static void require_conditional_effects();
/* Returns a simple type with the given name. */
static const Type& make_type(const std::string* name);
/* Returns the union of the given types. */
static Type make_type(const TypeSet& types);
/* Returns a simple term with the given name. */
static Term make_term(const std::string* name);
/* Creates a predicate with the given name. */
static void make_predicate(const std::string* name);
/* Creates a function with the given name. */
static void make_function(const std::string* name);
/* Creates an event with the given name. */
static void make_event(const std::string* name, bool controllable);
/* Adds the current event to the current domain. */
static void add_event();
/* Prepares for the parsing of a universally quantified effect. */ 
static void prepare_forall_effect();
/* Creates a universally quantified effect. */
static const Effect* make_forall_effect(const Effect& effect);
/* Adds an outcome to the given probabilistic effect. */
static void add_outcome(std::vector<std::pair<Rational, const Effect*> >& os,
			const Rational* p, const Effect& effect);
/* Creates a probabilistic effect. */
static const Effect*
make_prob_effect(const std::vector<std::pair<Rational, const Effect*> >* os);
/* Creates an add effect. */
static const Effect* make_add_effect(const Atom& atom);
/* Creates a delete effect. */
static const Effect* make_delete_effect(const Atom& atom);
/* Creates an assign update effect. */
static const Effect* make_assign_effect(const Fluent& fluent,
					const Expression& expr);
/* Creates a scale-up update effect. */
static const Effect* make_scale_up_effect(const Fluent& fluent,
					  const Expression& expr);
/* Creates a scale-down update effect. */
static const Effect* make_scale_down_effect(const Fluent& fluent,
					    const Expression& expr);
/* Creates an increase update effect. */
static const Effect* make_increase_effect(const Fluent& fluent,
					  const Expression& expr);
/* Creates a decrease update effect. */
static const Effect* make_decrease_effect(const Fluent& fluent,
					  const Expression& expr);
/* Adds types, constants, or objects to the current domain or problem. */
static void add_names(const std::vector<const std::string*>* names,
		      const Type& type);
/* Adds variables to the current variable list. */
static void add_variables(const std::vector<const std::string*>* names,
			  const Type& type);
/* Prepares for the parsing of an atomic state formula. */ 
static void prepare_atom(const std::string* name);
/* Prepares for the parsing of a fluent. */ 
static void prepare_fluent(const std::string* name);
/* Adds a term with the given name to the current atomic state formula. */
static void add_term(const std::string* name);
/* Creates the atomic formula just parsed. */
static const Atom* make_atom();
/* Creates the fluent just parsed. */
static const Fluent* make_fluent();
/* Creates a subtraction. */
static const Expression* make_subtraction(const Expression& term,
					  const Expression* opt_term);
/* Creates an atom or fluent for the given name to be used in an
   equality formula. */
static void make_eq_name(const std::string* name);
/* Creates an equality formula. */
static const StateFormula* make_equality();
/* Creates a negated formula. */
static const StateFormula* make_negation(const StateFormula& negand);
/* Creates an implication. */
static const StateFormula* make_implication(const StateFormula& f1,
					    const StateFormula& f2);
/* Prepares for the parsing of an existentially quantified formula. */
static void prepare_exists();
/* Prepares for the parsing of a universally quantified formula. */
static void prepare_forall();
/* Creates an existentially quantified formula. */
static const StateFormula* make_exists(const StateFormula& body);
/* Creates a universally quantified formula. */
static const StateFormula* make_forall(const StateFormula& body);
/* Adds a reward rate to the current problem. */
static void add_reward_rate(const StateFormula& condition,
			    const Rational* reward);
/* Sets the goal reward for the current problem. */
static void set_goal_reward(const Expression& goal_reward);
/* Sets the default metric for the current problem. */
static void set_default_metric();

#line 357 "parser.yy"
#ifndef YYSTYPE
typedef union {
  const Effect* effect;
  std::vector<std::pair<Rational, const Effect*> >* outcomes;
  const StateFormula* formula;
  const Atom* atom;
  const Distribution* dist;
  const Expression* expr;
  const Fluent* fluent;
  const Type* type;
  TypeSet* types;
  const std::string* str;
  std::vector<const std::string*>* strs;
  const Rational* num;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		593
#define	YYFLAG		-32768
#define	YYNTBASE	85

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 329 ? yytranslate[x] : 246)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      76,    77,    80,    79,     2,    78,     2,    81,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      83,    82,    84,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     5,     8,    11,    12,    22,    23,
      25,    28,    30,    32,    35,    37,    39,    41,    43,    46,
      49,    52,    54,    56,    58,    61,    64,    66,    68,    70,
      73,    76,    78,    80,    82,    85,    88,    90,    92,    95,
      97,    99,   102,   104,   106,   109,   111,   113,   116,   118,
     123,   125,   128,   130,   132,   134,   136,   138,   140,   142,
     144,   146,   148,   150,   152,   154,   156,   158,   160,   162,
     164,   166,   168,   169,   175,   176,   182,   187,   188,   194,
     195,   198,   199,   205,   206,   208,   212,   214,   217,   218,
     222,   223,   229,   230,   238,   239,   240,   249,   250,   251,
     260,   261,   266,   269,   271,   272,   274,   277,   280,   284,
     287,   289,   290,   292,   295,   298,   301,   306,   312,   318,
     324,   326,   332,   338,   344,   346,   351,   352,   361,   362,
     369,   374,   375,   378,   381,   385,   387,   389,   394,   395,
     402,   403,   410,   411,   418,   419,   426,   427,   434,   435,
     449,   452,   454,   457,   459,   462,   464,   467,   469,   470,
     476,   481,   482,   485,   487,   493,   498,   501,   505,   507,
     512,   513,   516,   518,   524,   526,   531,   532,   535,   538,
     544,   546,   548,   554,   555,   556,   563,   564,   571,   573,
     574,   581,   582,   589,   590,   597,   598,   605,   606,   613,
     618,   623,   624,   630,   636,   637,   646,   647,   656,   657,
     660,   661,   664,   665,   671,   673,   674,   680,   682,   684,
     690,   696,   702,   708,   710,   712,   713,   720,   721,   728,
     729,   736,   737,   744,   745,   751,   753,   755,   756,   758,
     759,   765,   767,   769,   775,   781,   787,   793,   795,   799,
     801,   805,   807,   808,   810,   811,   817,   819,   820,   823,
     826,   827,   830,   831,   833,   834,   839,   841,   844,   845,
     847,   848,   853,   855,   858,   859,   863,   865,   867,   872,
     874,   876,   879,   882,   884,   886,   888,   890,   892,   894,
     896,   898,   900,   902,   904,   906,   908,   910,   912,   914,
     916,   918,   920,   922,   924,   926,   928,   930,   932,   934,
     936,   938,   940,   942,   944,   946,   948,   950,   952,   954,
     956,   958,   960,   962,   964,   966,   968,   970,   972,   974,
     976,   978,   980,   982,   984,   986,   988,   990,   992,   994,
     996,   998,  1000,  1002,  1004,  1006,  1008,  1010,  1012,  1014,
    1016
};
static const short yyrhs[] =
{
      -1,    86,    87,     0,     0,    87,    88,     0,    87,   150,
       0,     0,    76,   216,    76,   217,   244,    77,    89,    90,
      77,     0,     0,   101,     0,   101,    91,     0,    91,     0,
     104,     0,   104,    92,     0,    92,     0,   106,     0,   108,
       0,   109,     0,   106,    93,     0,   108,    94,     0,   109,
      95,     0,    99,     0,   108,     0,   109,     0,   108,    96,
       0,   109,    97,     0,    99,     0,   106,     0,   109,     0,
     106,    96,     0,   109,    98,     0,    99,     0,   106,     0,
     108,     0,   106,    97,     0,   108,    98,     0,    99,     0,
     109,     0,   109,    99,     0,    99,     0,   108,     0,   108,
      99,     0,    99,     0,   106,     0,   106,    99,     0,    99,
       0,   100,     0,    99,   100,     0,   120,     0,    76,     6,
     102,    77,     0,   103,     0,   102,   103,     0,    11,     0,
      12,     0,    13,     0,    14,     0,    15,     0,    16,     0,
      17,     0,    18,     0,    19,     0,    20,     0,    21,     0,
      22,     0,    23,     0,    24,     0,    25,     0,    26,     0,
      27,     0,    28,     0,    29,     0,    30,     0,     0,    76,
       7,   105,   208,    77,     0,     0,    76,     8,   107,   208,
      77,     0,    76,     9,   111,    77,     0,     0,    76,    10,
     110,   114,    77,     0,     0,   111,   112,     0,     0,    76,
     242,   113,   205,    77,     0,     0,   115,     0,   115,   116,
     114,     0,   118,     0,   115,   118,     0,     0,    78,   117,
     215,     0,     0,    76,   243,   119,   205,    77,     0,     0,
      76,    31,   244,   121,   126,   127,    77,     0,     0,     0,
      76,    32,   122,   244,   123,   126,   130,    77,     0,     0,
       0,    76,    33,   124,   244,   125,   126,   130,    77,     0,
       0,    34,    76,   205,    77,     0,   129,   128,     0,   128,
       0,     0,   135,     0,    35,   174,     0,   134,   131,     0,
     133,   134,   132,     0,   133,   132,     0,   132,     0,     0,
     135,     0,    36,   174,     0,    37,   136,     0,    38,   138,
       0,    76,   219,   137,    77,     0,    76,   220,   137,   137,
      77,     0,    76,   221,   137,   137,    77,     0,    76,   222,
     137,   137,    77,     0,    74,     0,    76,    79,   137,   137,
      77,     0,    76,    80,   137,   137,    77,     0,    76,    81,
     137,   137,    77,     0,   144,     0,    76,   225,   141,    77,
       0,     0,    76,   229,   139,    76,   205,    77,   138,    77,
       0,     0,    76,   223,   140,   174,   138,    77,     0,    76,
     230,   142,    77,     0,     0,   141,   138,     0,   143,   138,
       0,   142,   143,   138,     0,    74,     0,   185,     0,    76,
     224,   185,    77,     0,     0,    76,   231,   145,   197,   189,
      77,     0,     0,    76,   232,   146,   197,   189,    77,     0,
       0,    76,   233,   147,   197,   189,    77,     0,     0,    76,
     234,   148,   197,   189,    77,     0,     0,    76,   235,   149,
     197,   189,    77,     0,     0,    76,   216,    76,   218,   244,
      77,    76,    39,   244,    77,   151,   152,    77,     0,   101,
     153,     0,   153,     0,   156,   154,     0,   154,     0,   158,
     155,     0,   155,     0,   166,   169,     0,   169,     0,     0,
      76,    40,   157,   208,    77,     0,    76,    41,   159,    77,
       0,     0,   159,   160,     0,   187,     0,    76,    82,   201,
     137,    77,     0,    76,   230,   161,    77,     0,   143,   162,
       0,   161,   143,   162,     0,   164,     0,    76,   225,   163,
      77,     0,     0,   163,   164,     0,   187,     0,    76,    82,
     201,   165,    77,     0,    74,     0,    76,    42,   167,    77,
       0,     0,   167,   168,     0,   174,   137,     0,    76,    43,
     174,    77,   170,     0,   171,     0,   171,     0,    76,    44,
     199,    77,   171,     0,     0,     0,    76,    45,   237,   172,
     199,    77,     0,     0,    76,    45,   236,   173,   199,    77,
       0,   185,     0,     0,    76,    82,   190,   175,   190,    77,
       0,     0,    76,    83,   176,   189,   189,    77,     0,     0,
      76,    70,   177,   189,   189,    77,     0,     0,    76,    71,
     178,   189,   189,    77,     0,     0,    76,    84,   179,   189,
     189,    77,     0,    76,   224,   174,    77,     0,    76,   225,
     183,    77,     0,     0,    76,   226,   180,   184,    77,     0,
      76,   227,   174,   174,    77,     0,     0,    76,   228,   181,
      76,   205,    77,   174,    77,     0,     0,    76,   229,   182,
      76,   205,    77,   174,    77,     0,     0,   183,   174,     0,
       0,   184,   174,     0,     0,    76,   242,   186,   203,    77,
       0,   242,     0,     0,    76,   242,   188,   204,    77,     0,
     242,     0,    74,     0,    76,    79,   189,   189,    77,     0,
      76,    78,   189,   196,    77,     0,    76,    80,   189,   189,
      77,     0,    76,    81,   189,   189,    77,     0,   197,     0,
      74,     0,     0,    76,    79,   191,   189,   189,    77,     0,
       0,    76,    78,   192,   189,   196,    77,     0,     0,    76,
      80,   193,   189,   189,    77,     0,     0,    76,    81,   194,
     189,   189,    77,     0,     0,    76,   243,   195,   203,    77,
       0,   244,     0,   245,     0,     0,   189,     0,     0,    76,
     243,   198,   203,    77,     0,   243,     0,    74,     0,    76,
      79,   199,   199,    77,     0,    76,    78,   199,   200,    77,
       0,    76,    80,   199,   199,    77,     0,    76,    81,   199,
     199,    77,     0,   201,     0,    76,    46,    77,     0,    46,
       0,    76,    47,    77,     0,    47,     0,     0,   199,     0,
       0,    76,   243,   202,   204,    77,     0,   243,     0,     0,
     203,   244,     0,   203,   245,     0,     0,   204,   244,     0,
       0,   207,     0,     0,   207,   211,   206,   205,     0,   245,
       0,   207,   245,     0,     0,   210,     0,     0,   210,   211,
     209,   208,     0,   244,     0,   210,   244,     0,     0,    78,
     212,   213,     0,   239,     0,   241,     0,    76,   240,   214,
      77,     0,   239,     0,   241,     0,   214,   239,     0,   214,
     241,     0,   238,     0,     3,     0,     4,     0,     5,     0,
      48,     0,    49,     0,    50,     0,    51,     0,    52,     0,
      53,     0,    54,     0,    55,     0,    56,     0,    57,     0,
      58,     0,    59,     0,    60,     0,    61,     0,    62,     0,
      63,     0,    64,     0,    65,     0,    66,     0,    67,     0,
      68,     0,    69,     0,     3,     0,     4,     0,     5,     0,
      69,     0,    48,     0,    49,     0,    50,     0,    51,     0,
      65,     0,    66,     0,    72,     0,   241,     0,    68,     0,
      67,     0,   244,     0,     3,     0,     4,     0,     5,     0,
      67,     0,    68,     0,    69,     0,    48,     0,    49,     0,
      50,     0,    51,     0,    52,     0,    53,     0,    54,     0,
      55,     0,    56,     0,    57,     0,    58,     0,    59,     0,
      60,     0,    61,     0,    62,     0,    63,     0,    64,     0,
      65,     0,    66,     0,    72,     0,    73,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   393,   393,   397,   398,   399,   406,   406,   410,   411,
     412,   413,   416,   417,   418,   421,   422,   423,   424,   425,
     426,   427,   430,   431,   432,   433,   434,   437,   438,   439,
     440,   441,   444,   445,   446,   447,   448,   451,   452,   453,
     456,   457,   458,   461,   462,   463,   466,   467,   470,   473,
     476,   477,   480,   481,   482,   484,   486,   487,   489,   491,
     493,   494,   495,   496,   501,   506,   511,   515,   520,   525,
     526,   527,   534,   534,   538,   538,   542,   545,   545,   552,
     553,   556,   556,   560,   561,   562,   565,   566,   569,   569,
     572,   572,   580,   580,   582,   582,   582,   585,   585,   585,
     590,   591,   594,   595,   598,   599,   602,   605,   606,   609,
     610,   613,   614,   617,   620,   623,   630,   632,   634,   636,
     640,   641,   643,   645,   652,   653,   654,   654,   656,   656,
     658,   662,   663,   666,   671,   675,   678,   679,   680,   680,
     682,   682,   684,   684,   686,   686,   688,   688,   696,   696,
     701,   702,   705,   706,   709,   710,   713,   714,   717,   717,
     721,   724,   725,   728,   729,   731,   735,   740,   744,   745,
     748,   749,   752,   753,   757,   760,   763,   764,   767,   770,
     771,   774,   775,   779,   780,   780,   782,   782,   789,   790,
     790,   793,   793,   795,   795,   797,   797,   799,   799,   801,
     802,   803,   803,   804,   805,   805,   807,   807,   811,   812,
     815,   816,   819,   819,   821,   824,   824,   826,   833,   834,
     835,   836,   837,   838,   841,   843,   843,   845,   845,   847,
     847,   849,   849,   851,   851,   853,   854,   857,   858,   861,
     861,   862,   865,   866,   868,   870,   872,   874,   875,   877,
     879,   881,   885,   886,   889,   889,   891,   898,   899,   900,
     903,   904,   907,   908,   909,   909,   913,   914,   917,   918,
     919,   919,   922,   923,   926,   926,   929,   930,   931,   934,
     935,   936,   937,   940,   947,   950,   953,   956,   959,   962,
     965,   968,   971,   974,   977,   980,   983,   986,   989,   992,
     995,   998,  1001,  1004,  1007,  1010,  1013,  1016,  1019,  1022,
    1022,  1022,  1023,  1024,  1024,  1024,  1024,  1025,  1025,  1026,
    1029,  1030,  1030,  1033,  1036,  1036,  1036,  1037,  1037,  1037,
    1038,  1038,  1038,  1038,  1039,  1039,  1039,  1039,  1039,  1039,
    1039,  1039,  1040,  1040,  1040,  1040,  1040,  1041,  1041,  1042,
    1045
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "DEFINE", "DOMAIN_TOKEN", "PROBLEM", 
  "REQUIREMENTS", "TYPES", "CONSTANTS", "PREDICATES", "FUNCTIONS", 
  "STRIPS", "TYPING", "NEGATIVE_PRECONDITIONS", 
  "DISJUNCTIVE_PRECONDITIONS", "EQUALITY", "EXISTENTIAL_PRECONDITIONS", 
  "UNIVERSAL_PRECONDITIONS", "QUANTIFIED_PRECONDITIONS", 
  "CONDITIONAL_EFFECTS", "FLUENTS", "ADL", "DURATIVE_ACTIONS", 
  "DURATION_INEQUALITIES", "CONTINUOUS_EFFECTS", "PROBABILISTIC_EFFECTS", 
  "REWARDS", "MDP", "DELAYED_ACTIONS", "EXOGENOUS_EVENTS", "GSMDP", 
  "ACTION", "DELAYED_ACTION", "DELAYED_EVENT", "PARAMETERS", 
  "PRECONDITION", "CONDITION", "DELAY", "EFFECT", "PDOMAIN", "OBJECTS", 
  "INIT", "REWARD_RATE", "GOAL", "GOAL_REWARD", "METRIC", "TOTAL_TIME", 
  "GOAL_ACHIEVED", "EXPONENTIAL", "WEIBULL", "LOGNORMAL", "UNIFORM", 
  "WHEN", "NOT", "AND", "OR", "IMPLY", "EXISTS", "FORALL", 
  "PROBABILISTIC", "ASSIGN", "SCALE_UP", "SCALE_DOWN", "INCREASE", 
  "DECREASE", "MINIMIZE", "MAXIMIZE", "NUMBER_TOKEN", "OBJECT_TOKEN", 
  "EITHER", "LE", "GE", "NAME", "VARIABLE", "NUMBER", "ILLEGAL_TOKEN", 
  "'('", "')'", "'-'", "'+'", "'*'", "'/'", "'='", "'<'", "'>'", "file", 
  "@1", "domains_and_problems", "domain_def", "@2", "domain_body", 
  "domain_body2", "domain_body3", "domain_body4", "domain_body5", 
  "domain_body6", "domain_body7", "domain_body8", "domain_body9", 
  "structure_defs", "structure_def", "require_def", "require_keys", 
  "require_key", "types_def", "@3", "constants_def", "@4", 
  "predicates_def", "functions_def", "@5", "predicate_decls", 
  "predicate_decl", "@6", "function_decls", "function_decl_seq", 
  "function_type_spec", "@7", "function_decl", "@8", "event_def", "@9", 
  "@10", "@11", "@12", "@13", "parameters", "action_body", "action_body2", 
  "precondition", "event_body", "event_body2", "opt_effect", "condition", 
  "delay", "effect", "distribution", "const_expr", "eff_formula", "@14", 
  "@15", "eff_formulas", "prob_effs", "probability", "p_effect", "@16", 
  "@17", "@18", "@19", "@20", "problem_def", "@21", "problem_body", 
  "problem_body2", "problem_body3", "problem_body4", "object_decl", "@22", 
  "init", "init_elements", "init_element", "prob_inits", "simple_init", 
  "one_inits", "one_init", "value", "reward_rate_decl", "state_rewards", 
  "state_reward", "goal_spec", "goal_reward", "metric_spec", "@23", "@24", 
  "formula", "@25", "@26", "@27", "@28", "@29", "@30", "@31", "@32", 
  "conjuncts", "disjuncts", "atomic_term_formula", "@33", 
  "atomic_name_formula", "@34", "f_exp", "term_or_f_exp", "@35", "@36", 
  "@37", "@38", "@39", "opt_f_exp", "f_head", "@40", "ground_f_exp", 
  "opt_ground_f_exp", "ground_f_head", "@41", "terms", "names", 
  "variables", "@42", "variable_seq", "typed_names", "@43", "name_seq", 
  "type_spec", "@44", "type", "types", "function_type", "define", 
  "domain", "problem", "exponential", "weibull", "lognormal", "uniform", 
  "when", "not", "and", "or", "imply", "exists", "forall", 
  "probabilistic", "assign", "scale_up", "scale_down", "increase", 
  "decrease", "minimize", "maximize", "number", "object", "either", 
  "type_name", "predicate", "function", "name", "variable", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    86,    85,    87,    87,    87,    89,    88,    90,    90,
      90,    90,    91,    91,    91,    92,    92,    92,    92,    92,
      92,    92,    93,    93,    93,    93,    93,    94,    94,    94,
      94,    94,    95,    95,    95,    95,    95,    96,    96,    96,
      97,    97,    97,    98,    98,    98,    99,    99,   100,   101,
     102,   102,   103,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   105,   104,   107,   106,   108,   110,   109,   111,
     111,   113,   112,   114,   114,   114,   115,   115,   117,   116,
     119,   118,   121,   120,   122,   123,   120,   124,   125,   120,
     126,   126,   127,   127,   128,   128,   129,   130,   130,   131,
     131,   132,   132,   133,   134,   135,   136,   136,   136,   136,
     137,   137,   137,   137,   138,   138,   139,   138,   140,   138,
     138,   141,   141,   142,   142,   143,   144,   144,   145,   144,
     146,   144,   147,   144,   148,   144,   149,   144,   151,   150,
     152,   152,   153,   153,   154,   154,   155,   155,   157,   156,
     158,   159,   159,   160,   160,   160,   161,   161,   162,   162,
     163,   163,   164,   164,   165,   166,   167,   167,   168,   169,
     169,   170,   170,   171,   172,   171,   173,   171,   174,   175,
     174,   176,   174,   177,   174,   178,   174,   179,   174,   174,
     174,   180,   174,   174,   181,   174,   182,   174,   183,   183,
     184,   184,   186,   185,   185,   188,   187,   187,   189,   189,
     189,   189,   189,   189,   190,   191,   190,   192,   190,   193,
     190,   194,   190,   195,   190,   190,   190,   196,   196,   198,
     197,   197,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   200,   200,   202,   201,   201,   203,   203,   203,
     204,   204,   205,   205,   206,   205,   207,   207,   208,   208,
     209,   208,   210,   210,   212,   211,   213,   213,   213,   214,
     214,   214,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     242,   242,   242,   243,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     245
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     0,     2,     2,     0,     9,     0,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     2,     2,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     1,     2,     1,
       1,     2,     1,     1,     2,     1,     1,     2,     1,     4,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     0,     5,     4,     0,     5,     0,
       2,     0,     5,     0,     1,     3,     1,     2,     0,     3,
       0,     5,     0,     7,     0,     0,     8,     0,     0,     8,
       0,     4,     2,     1,     0,     1,     2,     2,     3,     2,
       1,     0,     1,     2,     2,     2,     4,     5,     5,     5,
       1,     5,     5,     5,     1,     4,     0,     8,     0,     6,
       4,     0,     2,     2,     3,     1,     1,     4,     0,     6,
       0,     6,     0,     6,     0,     6,     0,     6,     0,    13,
       2,     1,     2,     1,     2,     1,     2,     1,     0,     5,
       4,     0,     2,     1,     5,     4,     2,     3,     1,     4,
       0,     2,     1,     5,     1,     4,     0,     2,     2,     5,
       1,     1,     5,     0,     0,     6,     0,     6,     1,     0,
       6,     0,     6,     0,     6,     0,     6,     0,     6,     4,
       4,     0,     5,     5,     0,     8,     0,     8,     0,     2,
       0,     2,     0,     5,     1,     0,     5,     1,     1,     5,
       5,     5,     5,     1,     1,     0,     6,     0,     6,     0,
       6,     0,     6,     0,     5,     1,     1,     0,     1,     0,
       5,     1,     1,     5,     5,     5,     5,     1,     3,     1,
       3,     1,     0,     1,     0,     5,     1,     0,     2,     2,
       0,     2,     0,     1,     0,     4,     1,     2,     0,     1,
       0,     4,     1,     2,     0,     3,     1,     1,     4,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     3,     2,     0,     4,     5,   284,     0,     0,   285,
     286,     0,     0,   324,   325,   326,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   327,   328,   329,   349,     0,
       0,     6,     0,     8,     0,     0,     0,    11,    14,    21,
      46,     9,    12,    15,    16,    17,    48,     0,     0,    72,
      74,    79,    77,     0,    94,    97,     7,     0,    47,     0,
      10,     0,    13,     0,    18,    26,    22,    23,     0,    19,
      31,    27,    28,     0,    20,    36,    32,    33,     0,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,     0,
      50,   268,   268,     0,    83,    92,     0,     0,     0,    24,
      39,    37,     0,    25,    42,    40,    29,     0,    30,    45,
      43,    34,    35,   148,    49,    51,     0,   269,   272,     0,
       0,    76,    80,     0,     0,    84,    86,   100,    95,    98,
      38,    41,    44,   183,    73,   274,   270,   273,    75,   309,
     310,   311,   313,   314,   315,   316,   317,   318,   322,   321,
     312,   319,   320,    81,    90,   323,    78,    88,    83,    87,
       0,   104,   100,   100,     0,   183,     0,   151,   153,   155,
     183,   183,   183,   157,   180,     0,   268,   262,   262,     0,
      85,   262,     0,     0,     0,   103,   104,   105,     0,     0,
     158,   161,   176,     0,     0,     0,   150,   149,     0,   152,
       0,   154,     0,   156,   307,     0,   275,   276,   277,   271,
     350,     0,   263,   266,     0,   306,    89,   283,     0,     0,
     106,   188,   214,     0,   115,   124,   136,    93,   102,     0,
       0,     0,     0,   111,     0,   268,     0,     0,     0,   304,
     305,   186,   184,   308,     0,    82,   264,   267,    91,   101,
     292,   293,   294,   295,   296,   297,   193,   195,     0,   191,
     197,     0,   208,   201,     0,   204,   206,   212,   291,   298,
     299,   300,   301,   302,   303,   128,     0,   131,   126,     0,
     138,   140,   142,   144,   146,   113,     0,   114,    96,   111,
     107,   110,   111,   112,    99,     0,     0,   160,   162,   163,
     217,   175,   177,     0,   183,     0,     0,     0,   279,   280,
     262,     0,     0,   224,     0,   189,   235,   236,     0,     0,
       0,     0,   210,     0,     0,     0,   257,     0,     0,     0,
       0,     0,   135,     0,     0,     0,     0,     0,     0,     0,
     287,   288,   289,   290,     0,     0,     0,     0,   108,   109,
     159,     0,     0,   215,   120,     0,   178,     0,   179,   181,
     249,   251,   242,     0,     0,   247,   256,     0,   278,   281,
     282,   265,   218,     0,     0,   223,   241,     0,   227,   225,
     229,   231,   233,     0,     0,     0,   199,   200,   209,     0,
       0,   262,   262,     0,     0,   137,   125,   132,   262,   130,
       0,   133,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   260,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   254,   187,   185,
       0,     0,     0,     0,   239,     0,     0,     0,     0,     0,
       0,   257,     0,     0,     0,   202,   211,   203,     0,     0,
     213,   258,   259,     0,     0,   134,     0,     0,     0,     0,
       0,   116,     0,     0,     0,     0,     0,   166,   168,   172,
     165,     0,     0,     0,     0,     0,     0,   248,   250,   252,
       0,     0,     0,   260,   237,     0,     0,     0,   257,   194,
     196,   237,     0,     0,     0,     0,   190,   192,   198,     0,
       0,   129,     0,   139,   141,   143,   145,   147,   117,   118,
     119,   164,     0,   170,   167,   216,   261,     0,     0,     0,
     183,   253,     0,     0,     0,     0,     0,   238,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,   121,   122,   123,     0,   182,   244,   243,
     245,   246,   255,   220,   219,   221,   222,   240,   228,   226,
     230,   232,   205,   207,   127,   174,     0,     0,   169,   171,
     173,     0,     0,     0
};

static const short yydefgoto[] =
{
     591,     1,     2,     4,    43,    46,    47,    48,    74,    79,
      84,   119,   123,   128,    49,    50,    51,   109,   110,    52,
     111,    53,   112,    54,    55,   114,   113,   142,   197,   144,
     145,   178,   199,   146,   198,    56,   147,   116,   182,   117,
     183,   181,   204,   205,   206,   251,   310,   311,   252,   253,
     313,   307,   376,   244,   351,   347,   350,   353,   354,   245,
     355,   356,   357,   358,   359,     5,   153,   186,   187,   188,
     189,   190,   255,   191,   256,   318,   435,   487,   562,   488,
     586,   192,   257,   322,   193,   378,   194,   326,   325,   240,
     403,   338,   331,   332,   339,   342,   344,   345,   341,   409,
     241,   346,   489,   436,   547,   335,   458,   457,   459,   460,
     461,   548,   395,   508,   384,   542,   385,   503,   413,   492,
     231,   330,   232,   136,   196,   137,   156,   195,   226,   327,
     236,     7,    11,    12,   364,   365,   366,   367,   295,   281,
     282,   283,   284,   285,   286,   299,   300,   301,   302,   303,
     304,   261,   262,   237,   227,   264,   172,   242,   396,   175,
     233
};

static const short yypact[] =
{
  -32768,-32768,   -59,    28,-32768,-32768,-32768,   -25,   117,-32768,
  -32768,  1400,  1400,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -20,
      -5,-32768,    18,    73,    37,   103,    31,-32768,-32768,    96,
  -32768,   116,   131,   142,   144,   148,-32768,  1400,  1532,-32768,
  -32768,-32768,-32768,  1400,-32768,-32768,-32768,     5,-32768,    60,
  -32768,    32,-32768,   137,-32768,    96,   156,   175,    65,-32768,
      96,   156,   176,   110,-32768,    96,   175,   176,   136,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   678,
  -32768,  1400,  1400,    62,   177,-32768,  1400,  1400,    92,-32768,
      96,    96,   210,-32768,    96,    96,-32768,   158,-32768,    96,
      96,-32768,-32768,-32768,-32768,-32768,   182,   679,-32768,   183,
    1470,-32768,-32768,  1400,   184,   -53,-32768,   220,-32768,-32768,
      96,    96,    96,   186,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   177,-32768,
     192,    -8,   220,   220,    13,   193,   195,-32768,-32768,-32768,
     194,   197,   199,-32768,-32768,  1368,  1400,   201,   201,   215,
  -32768,   201,  1279,  1318,   206,-32768,   248,-32768,   169,   169,
  -32768,-32768,-32768,  1279,   161,    87,-32768,-32768,   152,-32768,
     119,-32768,     0,-32768,-32768,   218,-32768,-32768,-32768,-32768,
  -32768,   211,   -49,-32768,   212,-32768,-32768,-32768,   219,   362,
  -32768,-32768,-32768,  1438,-32768,-32768,-32768,-32768,-32768,  1279,
     221,   222,   258,   129,   223,  1400,   445,   890,   224,-32768,
  -32768,-32768,-32768,-32768,  1288,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1135,-32768,
  -32768,  1279,-32768,-32768,  1279,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,  1330,-32768,-32768,   229,
  -32768,-32768,-32768,-32768,-32768,-32768,   198,-32768,-32768,   248,
  -32768,-32768,   248,-32768,-32768,   227,   309,-32768,-32768,-32768,
  -32768,-32768,-32768,   124,   240,  1100,  1100,  1065,-32768,-32768,
     201,  1174,  1174,-32768,   539,-32768,-32768,-32768,  1174,  1174,
     241,   925,-32768,  1279,   243,   245,-32768,  1279,  1470,   246,
     960,   250,-32768,     3,  1318,  1209,  1209,  1209,  1209,  1209,
  -32768,-32768,-32768,-32768,   124,   124,   124,   124,-32768,-32768,
  -32768,  1248,   229,-32768,-32768,    35,-32768,   185,-32768,-32768,
  -32768,-32768,-32768,   504,   247,-32768,-32768,   251,-32768,-32768,
  -32768,-32768,-32768,   574,  1174,-32768,-32768,  1174,-32768,-32768,
  -32768,-32768,-32768,  1135,  1174,  1174,-32768,-32768,-32768,   995,
     252,   201,   201,   713,  1318,-32768,-32768,-32768,   201,-32768,
    1318,-32768,  1400,  1174,  1174,  1174,  1174,  1174,   253,   124,
     124,   124,  1400,   124,  1359,   105,-32768,   124,   124,   124,
    1100,   254,   255,  1100,  1100,  1100,  1100,-32768,-32768,-32768,
    1174,  1174,  1174,  1174,-32768,   256,   257,  1174,  1174,  1174,
    1174,-32768,   259,   260,   261,-32768,-32768,-32768,   262,   263,
  -32768,-32768,-32768,   267,   268,-32768,   269,   270,   271,   272,
     274,-32768,   275,   276,   277,   279,   404,-32768,-32768,-32768,
  -32768,  1359,   820,   124,   124,   124,   292,-32768,-32768,  1100,
    1100,  1100,  1100,-32768,  1174,  1174,  1174,  1174,-32768,-32768,
  -32768,  1174,  1174,  1174,  1174,   749,-32768,-32768,-32768,  1279,
    1279,-32768,  1318,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,  1248,-32768,-32768,-32768,-32768,   293,   294,   295,
     297,-32768,   302,   303,   305,   306,   855,-32768,   307,   308,
     310,   311,   784,   312,   313,   316,   318,-32768,   319,   320,
     321,   325,  1030,-32768,-32768,-32768,   282,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   323,   434,-32768,-32768,
  -32768,   317,   335,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,-32768,   350,   334,-32768,-32768,
  -32768,   322,   328,   336,   594,   191,   283,-32768,   296,-32768,
  -32768,   -21,-32768,   -27,   -32,-32768,-32768,-32768,-32768,   226,
  -32768,-32768,-32768,   280,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    56,-32768,   200,-32768,   213,-32768,  -128,   168,   172,
    -146,-32768,  -279,  -336,-32768,-32768,-32768,-32768,  -340,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   278,   266,
     244,-32768,-32768,-32768,-32768,-32768,-32768,   -51,-32768,  -121,
  -32768,-32768,-32768,-32768,   265,-32768,  -315,-32768,-32768,  -210,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    -197,-32768,   187,-32768,  -249,    39,-32768,-32768,-32768,-32768,
  -32768,   -64,   -78,-32768,  -209,-32768,  -361,-32768,  -446,   -44,
    -190,-32768,-32768,   -92,-32768,-32768,   228,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   225,
    -236,-32768,-32768,-32768,   231,   145,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,  -248,-32768,  -183,  -136,  -138,   -11,
    -230
};


#define	YYLAST		1562


static const short yytable[] =
{
      39,    40,   267,   258,   173,   174,   246,   297,   234,   379,
     433,   238,   228,   420,   417,   515,   328,     3,   421,    58,
     139,    77,    82,   143,   230,   177,    76,   202,    87,   155,
     203,     6,   434,    81,    86,   207,    63,    64,    65,   305,
      60,    61,    62,   213,   121,   214,    88,   323,   337,   121,
     125,     8,   115,   210,   211,   212,   213,    41,   214,   125,
     207,   130,   552,    63,    64,    65,   130,    59,    60,    61,
      62,   340,    42,    60,   343,    62,    57,   352,   473,   389,
     419,   329,   394,   397,   475,   428,   429,   430,   431,   404,
     405,    63,    64,    65,    44,   491,    63,    64,    65,   349,
     138,   138,    62,   287,   229,   148,   149,   287,    66,    58,
      59,    60,    61,    62,   437,   438,   439,   387,    60,    61,
     320,     9,    10,    63,    64,    65,   157,   210,   211,   212,
     213,   408,   214,   410,    63,    64,    65,   414,   140,   141,
     391,    63,    64,    65,   390,   455,    61,    62,   456,    45,
     482,   483,   484,   246,   485,   463,   464,   246,   493,   494,
     495,   212,   213,   315,   214,   249,    60,   203,    63,    64,
      65,   561,    67,   337,   476,   477,   478,   479,   480,   352,
     373,   368,   490,   472,   369,   138,   560,   386,   386,    63,
      64,    65,    69,   211,   212,   213,   402,   214,   374,   466,
     375,   504,   505,   506,   507,   249,   250,    71,   511,   512,
     513,   514,   287,   133,   537,   538,   539,   246,    73,    61,
      78,   468,   469,   246,    83,   567,   259,   260,   474,   440,
     214,   496,   118,   386,   499,   500,   501,   502,   208,   209,
      68,    63,    64,    65,   138,   447,   360,   361,   362,   363,
     533,   122,   127,   143,   180,   454,   549,   550,   551,   154,
     158,   176,   184,   554,   555,   556,    68,   336,   201,   215,
     218,    68,   217,   220,   230,   222,    68,   423,   424,   425,
     426,   427,   235,   247,   454,   472,   203,   263,   265,   268,
     541,   543,   544,   545,   447,   250,   269,   306,   320,   308,
     314,   324,   386,   352,   370,   386,   386,   386,   386,   558,
     559,    68,   159,   160,   161,    68,   377,   592,   406,   411,
      68,   412,   472,   415,   448,   246,   418,   214,   449,   467,
     481,   497,   498,   509,   510,   593,   516,   517,   518,   519,
     520,    68,    68,    68,   521,   522,   523,   524,   525,   526,
     373,   527,   528,   529,   530,   320,   531,   162,   163,   164,
     165,   386,   386,   386,   386,   159,   160,   161,   289,   540,
     563,   564,   565,   566,   166,   167,   168,   169,   170,   568,
     569,   171,   570,   571,   573,   574,    72,   575,   576,   578,
     579,   371,   336,   580,   386,   581,   582,   583,   584,   585,
     590,    70,   471,   126,   200,   135,   248,   159,   160,   161,
     162,   163,   164,   165,   131,   270,   271,   272,   273,   274,
     275,   312,   254,   132,   309,   179,   320,   166,   167,   168,
     169,   170,   276,   277,   171,   221,   185,   159,   160,   161,
     534,   589,   462,   319,   278,   279,   280,   553,   159,   160,
     161,   373,   162,   163,   164,   165,   219,   223,   271,   546,
     266,   372,     0,   216,     0,     0,     0,     0,   296,   166,
     167,   168,   169,   170,   298,     0,   171,     0,     0,     0,
       0,   536,   162,   163,   164,   165,   532,     0,     0,     0,
       0,     0,     0,   162,   163,   164,   165,     0,     0,   166,
     167,   168,   169,   170,   471,     0,   171,    13,    14,    15,
     166,   167,   168,   169,   170,     0,   532,   171,     0,     0,
       0,   316,   317,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   536,     0,     0,     0,     0,
       0,   471,    13,    14,    15,     0,     0,     0,     0,     0,
     441,   442,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,     0,    38,    13,    14,    15,
       0,     0,   443,   444,   445,   446,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,     0,
       0,    38,     0,     0,     0,     0,     0,   398,   399,   400,
     401,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,     0,    38,    75,    80,    85,
       0,     0,   450,   451,   452,   453,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     120,   124,     0,     0,     0,   120,   129,     0,     0,     0,
     124,   129,    13,    14,    15,     0,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,     0,
       0,     0,     0,     0,     0,   150,    13,    14,    15,   151,
       0,     0,     0,     0,   152,     0,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,     0,
       0,    38,    13,    14,    15,   134,     0,   155,     0,     0,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,     0,     0,    38,   230,    13,    14,    15,
     470,     0,     0,     0,     0,     0,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,     0,
       0,    38,   230,    13,    14,    15,   557,     0,     0,     0,
       0,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,     0,    38,   230,    13,    14,
      15,   577,     0,     0,     0,     0,     0,     0,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
       0,     0,    38,   159,   160,   161,     0,   535,     0,     0,
       0,     0,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,     0,     0,    38,   159,   160,
     161,     0,   572,     0,     0,     0,     0,     0,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   167,   168,   169,   170,
       0,     0,   171,   159,   160,   161,   239,   321,     0,     0,
       0,     0,     0,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     166,   167,   168,   169,   170,     0,     0,   171,   159,   160,
     161,   239,   407,     0,     0,     0,     0,     0,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   167,   168,   169,   170,
       0,     0,   171,   159,   160,   161,   243,   416,     0,     0,
       0,     0,     0,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     166,   167,   168,   169,   170,     0,     0,   171,   159,   160,
     161,   239,   465,     0,     0,     0,     0,     0,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   167,   168,   169,   170,
       0,     0,   171,    13,    14,    15,   587,   588,     0,     0,
       0,     0,     0,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     166,   167,     0,   224,   170,     0,     0,   171,    13,    14,
      15,     0,   388,     0,     0,     0,   380,   381,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
       0,     0,    38,     0,   382,     0,   383,    13,    14,    15,
       0,     0,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,     0,     0,    38,   230,   333,
       0,   334,    13,    14,    15,     0,     0,     0,     0,     0,
       0,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,     0,    38,     0,   392,     0,
     393,    13,    14,    15,     0,     0,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,     0,
       0,    38,   159,   160,   161,   422,     0,     0,     0,     0,
       0,   159,   160,   161,     0,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,     0,     0,
      38,   159,   160,   161,   432,     0,     0,   162,   163,   164,
     165,     0,     0,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,   166,   167,   168,   169,   170,     0,
       0,   171,     0,   166,   167,   239,   224,   170,     0,     0,
     171,     0,   159,   160,   161,     0,   162,   163,   164,   165,
       0,   159,   160,   161,     0,     0,     0,     0,   162,   163,
     164,   165,     0,   166,   167,   168,   169,   170,     0,     0,
     171,     0,     0,     0,   243,   166,   167,   168,   169,   170,
       0,     0,   171,    13,    14,    15,   348,   162,   163,   164,
     165,     0,     0,     0,     0,     0,   162,   163,   164,   165,
       0,     0,     0,     0,   166,   167,   168,   169,   170,     0,
       0,   171,     0,   166,   167,   486,   224,   170,     0,     0,
     171,   159,   160,   161,   225,     0,     0,     0,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
       0,     0,    38,   159,   160,   161,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   162,   163,   164,   165,
     288,   270,   271,     0,     0,     0,   275,   289,   290,   291,
     292,   293,   294,   166,   167,   168,   169,   170,     0,     0,
     171,     0,     0,     0,     0,     0,     0,     0,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   167,   168,   169,   170,
       0,     0,   171,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108
};

static const short yycheck[] =
{
      11,    12,   232,   213,   140,   143,   203,   243,   198,   324,
     371,   201,   195,   353,   350,   461,   264,    76,   354,     6,
     112,    53,    54,    76,    73,    78,    53,    35,    55,    78,
      38,     3,   372,    54,    55,   181,    31,    32,    33,   249,
       8,     9,    10,    43,    76,    45,    57,   257,   278,    81,
      77,    76,    63,    40,    41,    42,    43,    77,    45,    86,
     206,    82,   508,    31,    32,    33,    87,     7,     8,     9,
      10,   281,    77,     8,   284,    10,    39,    74,   414,   327,
      77,   264,   331,   332,   420,   364,   365,   366,   367,   338,
     339,    31,    32,    33,    76,   435,    31,    32,    33,   296,
     111,   112,    10,   239,   196,   116,   117,   243,    77,     6,
       7,     8,     9,    10,    79,    80,    81,   326,     8,     9,
     256,     4,     5,    31,    32,    33,   137,    40,    41,    42,
      43,   341,    45,   343,    31,    32,    33,   347,    76,    77,
     330,    31,    32,    33,   327,   394,     9,    10,   397,    76,
     429,   430,   431,   350,   433,   404,   405,   354,   437,   438,
     439,    42,    43,   255,    45,    36,     8,    38,    31,    32,
      33,   532,    76,   403,   423,   424,   425,   426,   427,    74,
     316,   309,    77,   413,   312,   196,   522,   325,   326,    31,
      32,    33,    76,    41,    42,    43,   334,    45,    74,   409,
      76,   450,   451,   452,   453,    36,    37,    76,   457,   458,
     459,   460,   348,    77,   493,   494,   495,   414,    76,     9,
      76,   411,   412,   420,    76,   540,    65,    66,   418,    44,
      45,   440,    76,   371,   443,   444,   445,   446,   182,   183,
      49,    31,    32,    33,   255,   383,    48,    49,    50,    51,
     486,    76,    76,    76,    34,   393,   505,   506,   507,    77,
      77,    77,    76,   512,   513,   514,    75,   278,    76,    76,
      76,    80,    77,    76,    73,    76,    85,   355,   356,   357,
     358,   359,    67,    77,   422,   515,    38,    69,    77,    77,
     499,   500,   501,   502,   432,    37,    77,    76,   434,    77,
      77,    77,   440,    74,    77,   443,   444,   445,   446,   519,
     520,   120,     3,     4,     5,   124,    76,     0,    77,    76,
     129,    76,   552,    77,    77,   522,    76,    45,    77,    77,
      77,    77,    77,    77,    77,     0,    77,    77,    77,    77,
      77,   150,   151,   152,    77,    77,    77,    77,    77,    77,
     486,    77,    77,    77,    77,   491,    77,    48,    49,    50,
      51,   499,   500,   501,   502,     3,     4,     5,    59,    77,
      77,    77,    77,    76,    65,    66,    67,    68,    69,    77,
      77,    72,    77,    77,    77,    77,    52,    77,    77,    77,
      77,    82,   403,    77,   532,    77,    77,    77,    77,    74,
      77,    51,   413,    81,   178,   109,   206,     3,     4,     5,
      48,    49,    50,    51,    86,    53,    54,    55,    56,    57,
      58,   253,   209,    87,   252,   145,   562,    65,    66,    67,
      68,    69,    70,    71,    72,   191,   153,     3,     4,     5,
     491,   562,   403,   256,    82,    83,    84,   511,     3,     4,
       5,   587,    48,    49,    50,    51,   190,   192,    54,   503,
     232,   316,    -1,   185,    -1,    -1,    -1,    -1,   243,    65,
      66,    67,    68,    69,   243,    -1,    72,    -1,    -1,    -1,
      -1,   492,    48,    49,    50,    51,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    -1,    -1,    65,
      66,    67,    68,    69,   515,    -1,    72,     3,     4,     5,
      65,    66,    67,    68,    69,    -1,    82,    72,    -1,    -1,
      -1,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   546,    -1,    -1,    -1,    -1,
      -1,   552,     3,     4,     5,    -1,    -1,    -1,    -1,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    72,     3,     4,     5,
      -1,    -1,    78,    79,    80,    81,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    72,    -1,    -1,    -1,    -1,    -1,    78,    79,    80,
      81,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    72,    53,    54,    55,
      -1,    -1,    78,    79,    80,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    -1,    -1,    -1,    81,    82,    -1,    -1,    -1,
      86,    87,     3,     4,     5,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,   121,     3,     4,     5,   125,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    72,     3,     4,     5,    77,    -1,    78,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    -1,    72,    73,     3,     4,     5,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    72,    73,     3,     4,     5,    77,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    72,    73,     3,     4,
       5,    77,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,    72,     3,     4,
       5,    -1,    77,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    76,    77,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    72,     3,     4,
       5,    76,    77,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    76,    77,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    -1,    -1,    72,     3,     4,
       5,    76,    77,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    76,    77,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    -1,    68,    69,    -1,    -1,    72,     3,     4,
       5,    -1,    77,    -1,    -1,    -1,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    72,    -1,    74,    -1,    76,     3,     4,     5,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,    72,    73,    74,
      -1,    76,     3,     4,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    72,    -1,    74,    -1,
      76,     3,     4,     5,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    72,     3,     4,     5,    76,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      72,     3,     4,     5,    76,    -1,    -1,    48,    49,    50,
      51,    -1,    -1,     3,     4,     5,    48,    49,    50,    51,
      -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    72,    -1,    65,    66,    76,    68,    69,    -1,    -1,
      72,    -1,     3,     4,     5,    -1,    48,    49,    50,    51,
      -1,     3,     4,     5,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    -1,    65,    66,    67,    68,    69,    -1,    -1,
      72,    -1,    -1,    -1,    76,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    76,    48,    49,    50,
      51,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,    -1,
      -1,    72,    -1,    65,    66,    76,    68,    69,    -1,    -1,
      72,     3,     4,     5,    76,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    72,     3,     4,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      -1,    -1,    72,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 393 "parser.yy"
{ success = true; line_number = 1; }
    break;
case 2:
#line 394 "parser.yy"
{ if (!success) YYERROR; }
    break;
case 6:
#line 406 "parser.yy"
{ make_domain(yyvsp[-1].str); }
    break;
case 52:
#line 480 "parser.yy"
{ requirements->strips = true; }
    break;
case 53:
#line 481 "parser.yy"
{ requirements->typing = true; }
    break;
case 54:
#line 483 "parser.yy"
{ requirements->negative_preconditions = true; }
    break;
case 55:
#line 485 "parser.yy"
{ requirements->disjunctive_preconditions = true; }
    break;
case 56:
#line 486 "parser.yy"
{ requirements->equality = true; }
    break;
case 57:
#line 488 "parser.yy"
{ requirements->existential_preconditions = true; }
    break;
case 58:
#line 490 "parser.yy"
{ requirements->universal_preconditions = true; }
    break;
case 59:
#line 492 "parser.yy"
{ requirements->quantified_preconditions(); }
    break;
case 60:
#line 493 "parser.yy"
{ requirements->conditional_effects = true; }
    break;
case 61:
#line 494 "parser.yy"
{ requirements->fluents = true; }
    break;
case 62:
#line 495 "parser.yy"
{ requirements->adl(); }
    break;
case 63:
#line 497 "parser.yy"
{
		  throw std::runtime_error("`:durative-actions'"
					   " not supported");
		}
    break;
case 64:
#line 502 "parser.yy"
{
		  throw std::runtime_error("`:duration-inequalities'"
					   " not supported"); 
		}
    break;
case 65:
#line 507 "parser.yy"
{
		  throw std::runtime_error("`:continuous-effects'"
					   " not supported");
		}
    break;
case 66:
#line 512 "parser.yy"
{
		  requirements->probabilistic_effects = true;
		}
    break;
case 67:
#line 516 "parser.yy"
{
		  requirements->rewards = true;
		  reward_function = domain->functions().add_function("reward");
		}
    break;
case 68:
#line 521 "parser.yy"
{
		  requirements->mdp();
		  reward_function = domain->functions().add_function("reward");
		}
    break;
case 69:
#line 525 "parser.yy"
{ requirements->delayed_actions = true; }
    break;
case 70:
#line 526 "parser.yy"
{ requirements->exogenous_events = true; }
    break;
case 71:
#line 528 "parser.yy"
{
		  requirements->gsmdp();
		  reward_function = domain->functions().add_function("reward");
		}
    break;
case 72:
#line 534 "parser.yy"
{ require_typing(); name_kind = TYPE_KIND; }
    break;
case 73:
#line 535 "parser.yy"
{ name_kind = VOID_KIND; }
    break;
case 74:
#line 538 "parser.yy"
{ name_kind = CONSTANT_KIND; }
    break;
case 75:
#line 539 "parser.yy"
{ name_kind = VOID_KIND; }
    break;
case 77:
#line 545 "parser.yy"
{ require_fluents(); }
    break;
case 81:
#line 556 "parser.yy"
{ make_predicate(yyvsp[0].str); }
    break;
case 82:
#line 557 "parser.yy"
{ predicate = 0; }
    break;
case 88:
#line 569 "parser.yy"
{ require_typing(); }
    break;
case 90:
#line 572 "parser.yy"
{ make_function(yyvsp[0].str); }
    break;
case 91:
#line 573 "parser.yy"
{ function = 0; }
    break;
case 92:
#line 580 "parser.yy"
{ make_event(yyvsp[0].str, true); }
    break;
case 93:
#line 581 "parser.yy"
{ add_event(); }
    break;
case 94:
#line 582 "parser.yy"
{ require_delayed_actions(); }
    break;
case 95:
#line 583 "parser.yy"
{ make_event(yyvsp[0].str, true); }
    break;
case 96:
#line 584 "parser.yy"
{ add_event(); }
    break;
case 97:
#line 585 "parser.yy"
{ require_exogenous_events(); }
    break;
case 98:
#line 586 "parser.yy"
{ make_event(yyvsp[0].str, false); }
    break;
case 99:
#line 587 "parser.yy"
{ add_event(); }
    break;
case 106:
#line 602 "parser.yy"
{ event->set_condition(*yyvsp[0].formula); }
    break;
case 113:
#line 617 "parser.yy"
{ event->set_condition(*yyvsp[0].formula); }
    break;
case 114:
#line 620 "parser.yy"
{ event->set_delay(*yyvsp[0].dist); }
    break;
case 115:
#line 623 "parser.yy"
{ event->set_effect(*yyvsp[0].effect); }
    break;
case 116:
#line 631 "parser.yy"
{ yyval.dist = &Exponential::make(*yyvsp[-1].num); delete yyvsp[-1].num; }
    break;
case 117:
#line 633 "parser.yy"
{ yyval.dist = &Weibull::make(*yyvsp[-2].num, *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 118:
#line 635 "parser.yy"
{ yyval.dist = &Lognormal::make(*yyvsp[-2].num, *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 119:
#line 637 "parser.yy"
{ yyval.dist = &Uniform::make(*yyvsp[-2].num, *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 121:
#line 642 "parser.yy"
{ yyval.num = new Rational(*yyvsp[-2].num + *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 122:
#line 644 "parser.yy"
{ yyval.num = new Rational(*yyvsp[-2].num * *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 123:
#line 646 "parser.yy"
{ yyval.num = new Rational(*yyvsp[-2].num / *yyvsp[-1].num); delete yyvsp[-2].num; delete yyvsp[-1].num; }
    break;
case 125:
#line 653 "parser.yy"
{ yyval.effect = yyvsp[-1].effect; }
    break;
case 126:
#line 654 "parser.yy"
{ prepare_forall_effect(); }
    break;
case 127:
#line 655 "parser.yy"
{ yyval.effect = make_forall_effect(*yyvsp[-1].effect); }
    break;
case 128:
#line 656 "parser.yy"
{ require_conditional_effects(); }
    break;
case 129:
#line 657 "parser.yy"
{ yyval.effect = &ConditionalEffect::make(*yyvsp[-2].formula, *yyvsp[-1].effect); }
    break;
case 130:
#line 659 "parser.yy"
{ yyval.effect = make_prob_effect(yyvsp[-1].outcomes); }
    break;
case 131:
#line 662 "parser.yy"
{ yyval.effect = &Effect::EMPTY; }
    break;
case 132:
#line 663 "parser.yy"
{ yyval.effect = &(*yyvsp[-1].effect && *yyvsp[0].effect); }
    break;
case 133:
#line 667 "parser.yy"
{
		yyval.outcomes = new std::vector<std::pair<Rational, const Effect*> >();
		add_outcome(*yyval.outcomes, yyvsp[-1].num, *yyvsp[0].effect);
	      }
    break;
case 134:
#line 672 "parser.yy"
{ yyval.outcomes = yyvsp[-2].outcomes; add_outcome(*yyval.outcomes, yyvsp[-1].num, *yyvsp[0].effect); }
    break;
case 136:
#line 678 "parser.yy"
{ yyval.effect = make_add_effect(*yyvsp[0].atom); }
    break;
case 137:
#line 679 "parser.yy"
{ yyval.effect = make_delete_effect(*yyvsp[-1].atom); }
    break;
case 138:
#line 680 "parser.yy"
{ effect_fluent = true; }
    break;
case 139:
#line 681 "parser.yy"
{ yyval.effect = make_assign_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 140:
#line 682 "parser.yy"
{ effect_fluent = true; }
    break;
case 141:
#line 683 "parser.yy"
{ yyval.effect = make_scale_up_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 142:
#line 684 "parser.yy"
{ effect_fluent = true; }
    break;
case 143:
#line 685 "parser.yy"
{ yyval.effect = make_scale_down_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 144:
#line 686 "parser.yy"
{ effect_fluent = true; }
    break;
case 145:
#line 687 "parser.yy"
{ yyval.effect = make_increase_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 146:
#line 688 "parser.yy"
{ effect_fluent = true; }
    break;
case 147:
#line 689 "parser.yy"
{ yyval.effect = make_decrease_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 148:
#line 697 "parser.yy"
{ make_problem(yyvsp[-5].str, yyvsp[-1].str); }
    break;
case 149:
#line 698 "parser.yy"
{ problem->instantiate(); delete requirements; }
    break;
case 158:
#line 717 "parser.yy"
{ name_kind = OBJECT_KIND; }
    break;
case 159:
#line 718 "parser.yy"
{ name_kind = VOID_KIND; }
    break;
case 163:
#line 728 "parser.yy"
{ problem->add_init_atom(*yyvsp[0].atom); }
    break;
case 164:
#line 730 "parser.yy"
{ problem->add_init_value(*yyvsp[-2].fluent, *yyvsp[-1].num); delete yyvsp[-1].num; }
    break;
case 165:
#line 732 "parser.yy"
{ problem->add_init_effect(*make_prob_effect(yyvsp[-1].outcomes)); }
    break;
case 166:
#line 736 "parser.yy"
{
		 yyval.outcomes = new std::vector<std::pair<Rational, const Effect*> >();
		 add_outcome(*yyval.outcomes, yyvsp[-1].num, *yyvsp[0].effect);
	       }
    break;
case 167:
#line 741 "parser.yy"
{ yyval.outcomes = yyvsp[-2].outcomes; add_outcome(*yyval.outcomes, yyvsp[-1].num, *yyvsp[0].effect); }
    break;
case 169:
#line 745 "parser.yy"
{ yyval.effect = yyvsp[-1].effect; }
    break;
case 170:
#line 748 "parser.yy"
{ yyval.effect = &Effect::EMPTY; }
    break;
case 171:
#line 749 "parser.yy"
{ yyval.effect = &(*yyvsp[-1].effect && *yyvsp[0].effect); }
    break;
case 172:
#line 752 "parser.yy"
{ yyval.effect = make_add_effect(*yyvsp[0].atom); }
    break;
case 173:
#line 754 "parser.yy"
{ yyval.effect = make_assign_effect(*yyvsp[-2].fluent, *yyvsp[-1].expr); }
    break;
case 174:
#line 757 "parser.yy"
{ yyval.expr = new Value(*yyvsp[0].num); delete yyvsp[0].num; }
    break;
case 178:
#line 767 "parser.yy"
{ add_reward_rate(*yyvsp[-1].formula, yyvsp[0].num); }
    break;
case 179:
#line 770 "parser.yy"
{ problem->set_goal(*yyvsp[-2].formula); }
    break;
case 182:
#line 776 "parser.yy"
{ set_goal_reward(*yyvsp[-2].expr); }
    break;
case 183:
#line 779 "parser.yy"
{ set_default_metric(); }
    break;
case 184:
#line 780 "parser.yy"
{ metric_fluent = true; }
    break;
case 185:
#line 781 "parser.yy"
{ problem->set_metric(*yyvsp[-1].expr); metric_fluent = false; }
    break;
case 186:
#line 782 "parser.yy"
{ metric_fluent = true; }
    break;
case 187:
#line 783 "parser.yy"
{ problem->set_metric(*yyvsp[-1].expr, true); metric_fluent = false; }
    break;
case 188:
#line 789 "parser.yy"
{ yyval.formula = yyvsp[0].atom; }
    break;
case 189:
#line 791 "parser.yy"
{ first_eq_term = eq_term; first_eq_expr = eq_expr; }
    break;
case 190:
#line 792 "parser.yy"
{ yyval.formula = make_equality(); }
    break;
case 191:
#line 793 "parser.yy"
{ require_fluents(); }
    break;
case 192:
#line 794 "parser.yy"
{ yyval.formula = &LessThan::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 193:
#line 795 "parser.yy"
{ require_fluents(); }
    break;
case 194:
#line 796 "parser.yy"
{ yyval.formula = &LessThanOrEqualTo::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 195:
#line 797 "parser.yy"
{ require_fluents(); }
    break;
case 196:
#line 798 "parser.yy"
{ yyval.formula = &GreaterThanOrEqualTo::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 197:
#line 799 "parser.yy"
{ require_fluents(); }
    break;
case 198:
#line 800 "parser.yy"
{ yyval.formula = &GreaterThan::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 199:
#line 801 "parser.yy"
{ yyval.formula = make_negation(*yyvsp[-1].formula); }
    break;
case 200:
#line 802 "parser.yy"
{ yyval.formula = yyvsp[-1].formula; }
    break;
case 201:
#line 803 "parser.yy"
{ require_disjunction(); }
    break;
case 202:
#line 803 "parser.yy"
{ yyval.formula = yyvsp[-1].formula; }
    break;
case 203:
#line 804 "parser.yy"
{ yyval.formula = make_implication(*yyvsp[-2].formula, *yyvsp[-1].formula); }
    break;
case 204:
#line 805 "parser.yy"
{ prepare_exists(); }
    break;
case 205:
#line 806 "parser.yy"
{ yyval.formula = make_exists(*yyvsp[-1].formula); }
    break;
case 206:
#line 807 "parser.yy"
{ prepare_forall(); }
    break;
case 207:
#line 808 "parser.yy"
{ yyval.formula = make_forall(*yyvsp[-1].formula); }
    break;
case 208:
#line 811 "parser.yy"
{ yyval.formula = &StateFormula::TRUE; }
    break;
case 209:
#line 812 "parser.yy"
{ yyval.formula = &(*yyvsp[-1].formula && *yyvsp[0].formula); }
    break;
case 210:
#line 815 "parser.yy"
{ yyval.formula = &StateFormula::FALSE; }
    break;
case 211:
#line 816 "parser.yy"
{ yyval.formula = &(*yyvsp[-1].formula || *yyvsp[0].formula); }
    break;
case 212:
#line 819 "parser.yy"
{ prepare_atom(yyvsp[0].str); }
    break;
case 213:
#line 820 "parser.yy"
{ yyval.atom = make_atom(); }
    break;
case 214:
#line 821 "parser.yy"
{ prepare_atom(yyvsp[0].str); yyval.atom = make_atom(); }
    break;
case 215:
#line 824 "parser.yy"
{ prepare_atom(yyvsp[0].str); }
    break;
case 216:
#line 825 "parser.yy"
{ yyval.atom = make_atom(); }
    break;
case 217:
#line 826 "parser.yy"
{ prepare_atom(yyvsp[0].str); yyval.atom = make_atom(); }
    break;
case 218:
#line 833 "parser.yy"
{ yyval.expr = new Value(*yyvsp[0].num); delete yyvsp[0].num; }
    break;
case 219:
#line 834 "parser.yy"
{ yyval.expr = &Addition::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 220:
#line 835 "parser.yy"
{ yyval.expr = make_subtraction(*yyvsp[-2].expr, yyvsp[-1].expr); }
    break;
case 221:
#line 836 "parser.yy"
{ yyval.expr = &Multiplication::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 222:
#line 837 "parser.yy"
{ yyval.expr = &Division::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 223:
#line 838 "parser.yy"
{ yyval.expr = yyvsp[0].fluent; }
    break;
case 224:
#line 842 "parser.yy"
{ require_fluents(); eq_expr = new Value(*yyvsp[0].num); delete yyvsp[0].num; }
    break;
case 225:
#line 843 "parser.yy"
{ require_fluents(); }
    break;
case 226:
#line 844 "parser.yy"
{ eq_expr = &Addition::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 227:
#line 845 "parser.yy"
{ require_fluents(); }
    break;
case 228:
#line 846 "parser.yy"
{ eq_expr = make_subtraction(*yyvsp[-2].expr, yyvsp[-1].expr); }
    break;
case 229:
#line 847 "parser.yy"
{ require_fluents(); }
    break;
case 230:
#line 848 "parser.yy"
{ eq_expr = &Multiplication::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 231:
#line 849 "parser.yy"
{ require_fluents(); }
    break;
case 232:
#line 850 "parser.yy"
{ eq_expr = &Division::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 233:
#line 851 "parser.yy"
{ require_fluents(); prepare_fluent(yyvsp[0].str); }
    break;
case 234:
#line 852 "parser.yy"
{ eq_expr = make_fluent(); }
    break;
case 235:
#line 853 "parser.yy"
{ make_eq_name(yyvsp[0].str); }
    break;
case 236:
#line 854 "parser.yy"
{ eq_term = make_term(yyvsp[0].str); eq_expr = 0; }
    break;
case 237:
#line 857 "parser.yy"
{ yyval.expr = 0; }
    break;
case 239:
#line 861 "parser.yy"
{ prepare_fluent(yyvsp[0].str); }
    break;
case 240:
#line 861 "parser.yy"
{ yyval.fluent = make_fluent(); }
    break;
case 241:
#line 862 "parser.yy"
{ prepare_fluent(yyvsp[0].str); yyval.fluent = make_fluent(); }
    break;
case 242:
#line 865 "parser.yy"
{ yyval.expr = new Value(*yyvsp[0].num); delete yyvsp[0].num; }
    break;
case 243:
#line 867 "parser.yy"
{ yyval.expr = &Addition::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 244:
#line 869 "parser.yy"
{ yyval.expr = make_subtraction(*yyvsp[-2].expr, yyvsp[-1].expr); }
    break;
case 245:
#line 871 "parser.yy"
{ yyval.expr = &Multiplication::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 246:
#line 873 "parser.yy"
{ yyval.expr = &Division::make(*yyvsp[-2].expr, *yyvsp[-1].expr); }
    break;
case 247:
#line 874 "parser.yy"
{ yyval.expr = yyvsp[0].fluent; }
    break;
case 248:
#line 876 "parser.yy"
{ yyval.expr = &Fluent::make(domain->total_time(), TermList()); }
    break;
case 249:
#line 878 "parser.yy"
{ yyval.expr = &Fluent::make(domain->total_time(), TermList()); }
    break;
case 250:
#line 880 "parser.yy"
{ yyval.expr = &Fluent::make(domain->goal_achieved(), TermList()); }
    break;
case 251:
#line 882 "parser.yy"
{ yyval.expr = &Fluent::make(domain->goal_achieved(), TermList()); }
    break;
case 252:
#line 885 "parser.yy"
{ yyval.expr = 0; }
    break;
case 254:
#line 889 "parser.yy"
{ prepare_fluent(yyvsp[0].str); }
    break;
case 255:
#line 890 "parser.yy"
{ yyval.fluent = make_fluent(); }
    break;
case 256:
#line 891 "parser.yy"
{ prepare_fluent(yyvsp[0].str); yyval.fluent = make_fluent(); }
    break;
case 258:
#line 899 "parser.yy"
{ add_term(yyvsp[0].str); }
    break;
case 259:
#line 900 "parser.yy"
{ add_term(yyvsp[0].str); }
    break;
case 261:
#line 904 "parser.yy"
{ add_term(yyvsp[0].str); }
    break;
case 263:
#line 908 "parser.yy"
{ add_variables(yyvsp[0].strs, TypeTable::OBJECT); }
    break;
case 264:
#line 909 "parser.yy"
{ add_variables(yyvsp[-1].strs, *yyvsp[0].type); delete yyvsp[0].type; }
    break;
case 266:
#line 913 "parser.yy"
{ yyval.strs = new std::vector<const std::string*>(1, yyvsp[0].str); }
    break;
case 267:
#line 914 "parser.yy"
{ yyval.strs = yyvsp[-1].strs; yyval.strs->push_back(yyvsp[0].str); }
    break;
case 269:
#line 918 "parser.yy"
{ add_names(yyvsp[0].strs, TypeTable::OBJECT); }
    break;
case 270:
#line 919 "parser.yy"
{ add_names(yyvsp[-1].strs, *yyvsp[0].type); delete yyvsp[0].type; }
    break;
case 272:
#line 922 "parser.yy"
{ yyval.strs = new std::vector<const std::string*>(1, yyvsp[0].str); }
    break;
case 273:
#line 923 "parser.yy"
{ yyval.strs = yyvsp[-1].strs; yyval.strs->push_back(yyvsp[0].str); }
    break;
case 274:
#line 926 "parser.yy"
{ require_typing(); }
    break;
case 275:
#line 926 "parser.yy"
{ yyval.type = yyvsp[0].type; }
    break;
case 276:
#line 929 "parser.yy"
{ yyval.type = new Type(TypeTable::OBJECT); }
    break;
case 277:
#line 930 "parser.yy"
{ yyval.type = new Type(make_type(yyvsp[0].str)); }
    break;
case 278:
#line 931 "parser.yy"
{ yyval.type = new Type(make_type(*yyvsp[-1].types)); delete yyvsp[-1].types; }
    break;
case 279:
#line 934 "parser.yy"
{ yyval.types = new TypeSet(); }
    break;
case 280:
#line 935 "parser.yy"
{ yyval.types = new TypeSet(); yyval.types->insert(make_type(yyvsp[0].str)); }
    break;
case 281:
#line 936 "parser.yy"
{ yyval.types = yyvsp[-1].types; }
    break;
case 282:
#line 937 "parser.yy"
{ yyval.types = yyvsp[-1].types; yyval.types->insert(make_type(yyvsp[0].str)); }
    break;
case 284:
#line 947 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 285:
#line 950 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 286:
#line 953 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 287:
#line 956 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 288:
#line 959 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 289:
#line 962 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 290:
#line 965 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 291:
#line 968 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 292:
#line 971 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 293:
#line 974 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 294:
#line 977 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 295:
#line 980 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 296:
#line 983 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 297:
#line 986 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 298:
#line 989 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 299:
#line 992 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 300:
#line 995 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 301:
#line 998 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 302:
#line 1001 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 303:
#line 1004 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 304:
#line 1007 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 305:
#line 1010 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 306:
#line 1013 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 307:
#line 1016 "parser.yy"
{ delete yyvsp[0].str; }
    break;
case 308:
#line 1019 "parser.yy"
{ delete yyvsp[0].str; }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1048 "parser.yy"


/* Outputs an error message. */
static void yyerror(const std::string& s) {
  std::cerr << PACKAGE ":" << current_file << ':' << line_number << ": " << s
	    << std::endl;
  success = false;
}


/* Outputs a warning. */
static void yywarning(const std::string& s) {
  if (warning_level > 0) {
    std::cerr << PACKAGE ":" << current_file << ':' << line_number << ": " << s
	      << std::endl;
    if (warning_level > 1) {
      success = false;
    }
  }
}


/* Creates an empty domain with the given name. */
static void make_domain(const std::string* name) {
  domain = new Domain(*name);
  domains[*name] = std::make_pair(domain, Requirements());
  requirements = &domains[*name].second;
  problem = 0;
  delete name;
}


/* Creates an empty problem with the given name. */
static void make_problem(const std::string* name,
			 const std::string* domain_name) {
  std::map<std::string, std::pair<Domain*, Requirements> >::const_iterator di =
    domains.find(*domain_name);
  if (di != domains.end()) {
    domain = (*di).second.first;
    requirements = new Requirements((*di).second.second);
  } else {
    domain = new Domain(*domain_name);
    domains[*domain_name] = std::make_pair(domain, Requirements());
    requirements = new Requirements();
    yyerror("undeclared domain `" + *domain_name + "' used");
  }
  problem = new Problem(*name, *domain);
  const Fluent& total_time_fluent =
    Fluent::make(domain->total_time(), TermList());
  const Update* total_time_update =
    new Assign(total_time_fluent, *new Value(0));
  problem->add_init_effect(UpdateEffect::make(*total_time_update));
  const Fluent& goal_achieved_fluent =
    Fluent::make(domain->goal_achieved(), TermList());
  const Update* goal_achieved_update =
    new Assign(goal_achieved_fluent, *new Value(0));
  problem->add_init_effect(UpdateEffect::make(*goal_achieved_update));
  if (requirements->rewards) {
    reward_function = *domain->functions().find_function("reward");
    const Fluent& reward_fluent = Fluent::make(reward_function, TermList());
    const Update* reward_update = new Assign(reward_fluent, *new Value(0));
    problem->add_init_effect(UpdateEffect::make(*reward_update));
  }
  delete name;
  delete domain_name;
}


/* Adds :typing to the requirements. */
static void require_typing() {
  if (!requirements->typing) {
    yywarning("assuming `:typing' requirement");
    requirements->typing = true;
  }
}


/* Adds :delayed-actions to the requirements. */
static void require_delayed_actions() {
  if (!requirements->delayed_actions) {
    yywarning("assuming `:delayed-actions' requirement");
    requirements->delayed_actions = true;
  }
}


/* Adds :exogenous-events to the requirements. */
static void require_exogenous_events() {
  if (!requirements->exogenous_events) {
    yywarning("assuming `:exogenous-events' requirement");
    requirements->exogenous_events = true;
  }
}


/* Adds :fluents to the requirements. */
static void require_fluents() {
  if (!requirements->fluents) {
    yywarning("assuming `:fluents' requirement");
    requirements->fluents = true;
  }
}


/* Adds :disjunctive-preconditions to the requirements. */
static void require_disjunction() {
  if (!requirements->disjunctive_preconditions) {
    yywarning("assuming `:disjunctive-preconditions' requirement");
    requirements->disjunctive_preconditions = true;
  }
}


/* Adds :conditional-effects to the requirements. */ 
static void require_conditional_effects() {
  if (!requirements->conditional_effects) {
    yywarning("assuming `:conditional-effects' requirement");
    requirements->conditional_effects = true;
  }
}


/* Returns a simple type with the given name. */
static const Type& make_type(const std::string* name) {
  const Type* t = domain->types().find_type(*name);
  if (t == 0) {
    t = &domain->types().add_type(*name);
    if (name_kind != TYPE_KIND) {
      yywarning("implicit declaration of type `" + *name + "'");
    }
  }
  delete name;
  return *t;
}


/* Returns the union of the given types. */
static Type make_type(const TypeSet& types) {
  return TypeTable::union_type(types);
}


/* Returns a simple term with the given name. */
static Term make_term(const std::string* name) {
  if ((*name)[0] == '?') {
    const Variable* vp = context.find(*name);
    if (vp != 0) {
      delete name;
      return *vp;
    } else {
      Variable v = TermTable::add_variable(TypeTable::OBJECT);
      context.insert(*name, v);
      yyerror("free variable `" + *name + "' used");
      delete name;
      return v;
    }
  } else {
    TermTable& terms = (problem != 0) ? problem->terms() : domain->terms();
    const Object* o = terms.find_object(*name);
    if (o == 0) {
      size_t n = term_parameters.size();
      if (atom_predicate != 0
	  && PredicateTable::parameters(*atom_predicate).size() > n) {
	const Type& t = PredicateTable::parameters(*atom_predicate)[n];
	o = &terms.add_object(*name, t);
      } else {
	o = &terms.add_object(*name, TypeTable::OBJECT);
      }
      yywarning("implicit declaration of object `" + *name + "'");
    }
    delete name;
    return *o;
  }
}


/* Creates a predicate with the given name. */
static void make_predicate(const std::string* name) {
  predicate = domain->predicates().find_predicate(*name);
  if (predicate == 0) {
    repeated_predicate = false;
    predicate = &domain->predicates().add_predicate(*name);
  } else {
    repeated_predicate = true;
    yywarning("ignoring repeated declaration of predicate `" + *name + "'");
  }
  delete name;
}


/* Creates a function with the given name. */
static void make_function(const std::string* name) {
  repeated_function = false;
  function = domain->functions().find_function(*name);
  if (function == 0) {
    function = &domain->functions().add_function(*name);
  } else {
    repeated_function = true;
    if (requirements->rewards && *name == "reward") {
      yywarning("ignoring declaration of reserved function `reward'");
    } else if (*name == "total-time" || *name == "goal-achieved") {
      yywarning("ignoring declaration of reserved function `" + *name + "'");
    } else {
      yywarning("ignoring repeated declaration of function `" + *name + "'");
    }
  }
  delete name;
}


/* Creates an event with the given name. */
static void make_event(const std::string* name, bool controllable) {
  context.push_frame();
  event = new EventSchema(*name, controllable);
  delete name;
}


/* Adds the current event to the current domain. */
static void add_event() {
  context.pop_frame();
  if (domain->find_event(event->name()) == 0) {
    domain->add_event(*event);
  } else {
    yywarning("ignoring repeated declaration of event `"
	      + event->name() + "'");
    delete event;
  }
  event = 0;
}


/* Prepares for the parsing of a universally quantified effect. */ 
static void prepare_forall_effect() {
  if (!requirements->conditional_effects) {
    yywarning("assuming `:conditional-effects' requirement");
    requirements->conditional_effects = true;
  }
  context.push_frame();
  quantified.push_back(Term(0));
}


/* Creates a universally quantified effect. */
static const Effect* make_forall_effect(const Effect& effect) {
  context.pop_frame();
  size_t n = quantified.size() - 1;
  size_t m = n;
  while (quantified[n].variable()) {
    n--;
  }
  VariableList parameters;
  for (size_t i = n + 1; i <= m; i++) {
    parameters.push_back(quantified[i].as_variable());
  }
  quantified.resize(n, Term(0)); 
  return &QuantifiedEffect::make(parameters, effect);
}


/* Adds an outcome to the given probabilistic effect. */
static void add_outcome(std::vector<std::pair<Rational, const Effect*> >& os,
			const Rational* p, const Effect& effect) {
  if (!requirements->probabilistic_effects) {
    yywarning("assuming `:probabilistic-effects' requirement");
    requirements->probabilistic_effects = true;
  }
  if (*p < 0 || *p > 1) {
    yyerror("outcome probability needs to be in the interval [0,1]");
  }
  os.push_back(std::make_pair(*p, &effect));
  delete p;
}


/* Creates a probabilistic effect. */
static const Effect*
make_prob_effect(const std::vector<std::pair<Rational, const Effect*> >* os) {
  Rational psum = 0;
  for (size_t i = 0; i < os->size(); i++) {
    psum = psum + (*os)[i].first;
  }
  if (psum > 1) {
    yyerror("effect outcome probabilities add up to more than 1");
    delete os;
    return &Effect::EMPTY;
  } else {
    const Effect& peff = ProbabilisticEffect::make(*os);
    delete os;
    return &peff;
  }
}


/* Creates an add effect. */
static const Effect* make_add_effect(const Atom& atom) {
  PredicateTable::make_dynamic(atom.predicate());
  return new AddEffect(atom);
}


/* Creates a delete effect. */
static const Effect* make_delete_effect(const Atom& atom) {
  PredicateTable::make_dynamic(atom.predicate());
  return new DeleteEffect(atom);
}


/* Creates an assign update effect. */
static const Effect* make_assign_effect(const Fluent& fluent,
					const Expression& expr) {
  if (requirements->rewards && fluent.function() == reward_function) {
    yyerror("only constant reward increments/decrements allowed");
  } else {
    require_fluents();
  }
  effect_fluent = false;
  FunctionTable::make_dynamic(fluent.function());
  return &UpdateEffect::make(*new Assign(fluent, expr));
}


/* Creates a scale-up update effect. */
static const Effect* make_scale_up_effect(const Fluent& fluent,
					  const Expression& expr) {
  if (requirements->rewards && fluent.function() == reward_function) {
    yyerror("only constant reward increments/decrements allowed");
  } else {
    require_fluents();
  }
  effect_fluent = false;
  FunctionTable::make_dynamic(fluent.function());
  return &UpdateEffect::make(*new ScaleUp(fluent, expr));
}


/* Creates a scale-down update effect. */
static const Effect* make_scale_down_effect(const Fluent& fluent,
					    const Expression& expr) {
  if (requirements->rewards && fluent.function() == reward_function) {
    yyerror("only constant reward increments/decrements allowed");
  } else {
    require_fluents();
  }
  effect_fluent = false;
  FunctionTable::make_dynamic(fluent.function());
  return &UpdateEffect::make(*new ScaleDown(fluent, expr));
}


/* Creates an increase update effect. */
static const Effect* make_increase_effect(const Fluent& fluent,
					  const Expression& expr) {
  if (requirements->rewards && fluent.function() == reward_function) {
    if (typeid(expr) != typeid(Value)) {
      yyerror("only constant reward increments/decrements allowed");
    }
  } else {
    require_fluents();
  }
  effect_fluent = false;
  FunctionTable::make_dynamic(fluent.function());
  return &UpdateEffect::make(*new Increase(fluent, expr));
}


/* Creates a decrease update effect. */
static const Effect* make_decrease_effect(const Fluent& fluent,
					  const Expression& expr) {
  if (requirements->rewards && fluent.function() == reward_function) {
    if (typeid(expr) != typeid(Value)) {
      yyerror("only constant reward increments/decrements allowed");
    }
  } else {
    require_fluents();
  }
  effect_fluent = false;
  FunctionTable::make_dynamic(fluent.function());
  return &UpdateEffect::make(*new Decrease(fluent, expr));
}


/* Adds types, constants, or objects to the current domain or problem. */
static void add_names(const std::vector<const std::string*>* names,
		      const Type& type) {
  for (std::vector<const std::string*>::const_iterator si = names->begin();
       si != names->end(); si++) {
    const std::string* s = *si;
    if (name_kind == TYPE_KIND) {
      if (*s == TypeTable::OBJECT_NAME) {
	yywarning("ignoring declaration of reserved type `object'");
      } else if (*s == TypeTable::NUMBER_NAME) {
	yywarning("ignoring declaration of reserved type `number'");
      } else {
	const Type* t = domain->types().find_type(*s);
	if (t == 0) {
	  t = &domain->types().add_type(*s);
	}
	if (!TypeTable::add_supertype(*t, type)) {
	  yyerror("cyclic type hierarchy");
	}
      }
    } else if (name_kind == CONSTANT_KIND) {
      const Object* o = domain->terms().find_object(*s);
      if (o == 0) {
	domain->terms().add_object(*s, type);
      } else {
	TypeSet components;
	TypeTable::components(components, TermTable::type(*o));
	components.insert(type);
	TermTable::set_type(*o, make_type(components));
      }
    } else { /* name_kind == OBJECT_KIND */
      if (domain->terms().find_object(*s) != 0) {
	yywarning("ignoring declaration of object `" + *s
		  + "' previously declared as constant");
      } else {
	const Object* o = problem->terms().find_object(*s);
	if (o == 0) {
	  problem->terms().add_object(*s, type);
	} else {
	  TypeSet components;
	  TypeTable::components(components, TermTable::type(*o));
	  components.insert(type);
	  TermTable::set_type(*o, make_type(components));
	}
      }
    }
    delete s;
  }
  delete names;
}


/* Adds variables to the current variable list. */
static void add_variables(const std::vector<const std::string*>* names,
			  const Type& type) {
  for (std::vector<const std::string*>::const_iterator si = names->begin();
       si != names->end(); si++) {
    const std::string* s = *si;
    if (predicate != 0) {
      if (!repeated_predicate) {
	PredicateTable::add_parameter(*predicate, type);
      }
    } else if (function != 0) {
      if (!repeated_function) {
	FunctionTable::add_parameter(*function, type);
      }
    } else {
      if (context.shallow_find(*s) != 0) {
	yyerror("repetition of parameter `" + *s + "'");
      } else if (context.find(*s) != 0) {
	yywarning("shadowing parameter `" + *s + "'");
      }
      Variable var = TermTable::add_variable(type);
      context.insert(*s, var);
      if (!quantified.empty()) {
	quantified.push_back(var);
      } else { /* event != 0 */
	event->add_parameter(var);
      }
    }
    delete s;
  }
  delete names;
}


/* Prepares for the parsing of an atomic state formula. */ 
static void prepare_atom(const std::string* name) {
  atom_predicate = domain->predicates().find_predicate(*name);
  if (atom_predicate == 0) {
    atom_predicate = &domain->predicates().add_predicate(*name);
    undeclared_atom_predicate = true;
    if (problem != 0) {
      yywarning("undeclared predicate `" + *name + "' used");
    } else {
      yywarning("implicit declaration of predicate `" + *name + "'");
    }
  } else {
    undeclared_atom_predicate = false;
  }
  term_parameters.clear();
  delete name;
}


/* Prepares for the parsing of a fluent. */ 
static void prepare_fluent(const std::string* name) {
  fluent_function = domain->functions().find_function(*name);
  if (fluent_function == 0) {
    fluent_function = &domain->functions().add_function(*name);
    undeclared_fluent_function = true;
    if (problem != 0) {
      yywarning("undeclared function `" + *name + "' used");
    } else {
      yywarning("implicit declaration of function `" + *name + "'");
    }
  } else {
    undeclared_fluent_function = false;
  }
  if (requirements->rewards && *name == "reward") {
    if (!effect_fluent && !metric_fluent) {
      yyerror("reserved function `reward' not allowed here");
    }
  } else if ((*name == "total-time" || *name == "goal-achieved")) {
    if (!metric_fluent) {
      yyerror("reserved function `" + *name + "' not allowed here");
    }
  } else {
    require_fluents();
  }
  term_parameters.clear();
  delete name;
}


/* Adds a term with the given name to the current atomic state formula. */
static void add_term(const std::string* name) {
  const Term& term = make_term(name);
  if (atom_predicate != 0) {
    size_t n = term_parameters.size();
    if (undeclared_atom_predicate) {
      PredicateTable::add_parameter(*atom_predicate, TermTable::type(term));
    } else {
      const TypeList& params = PredicateTable::parameters(*atom_predicate);
      if (params.size() > n
	  && !TypeTable::subtype(TermTable::type(term), params[n])) {
	yyerror("type mismatch");
      }
    }
  } else if (fluent_function != 0) {
    size_t n = term_parameters.size();
    if (undeclared_fluent_function) {
      FunctionTable::add_parameter(*fluent_function, TermTable::type(term));
    } else {
      const TypeList& params = FunctionTable::parameters(*fluent_function);
      if (params.size() > n
	  && !TypeTable::subtype(TermTable::type(term), params[n])) {
	yyerror("type mismatch");
      }
    }
  }
  term_parameters.push_back(term);
}


/* Creates the atomic formula just parsed. */
static const Atom* make_atom() {
  size_t n = term_parameters.size();
  if (PredicateTable::parameters(*atom_predicate).size() < n) {
    yyerror("too many parameters passed to predicate `"
	    + PredicateTable::name(*atom_predicate) + "'");
  } else if (PredicateTable::parameters(*atom_predicate).size() > n) {
    yyerror("too few parameters passed to predicate `"
	    + PredicateTable::name(*atom_predicate) + "'");
  }
  const Atom& atom = Atom::make(*atom_predicate, term_parameters);
  atom_predicate = 0;
  return &atom;
}


/* Creates the fluent just parsed. */
static const Fluent* make_fluent() {
  size_t n = term_parameters.size();
  if (FunctionTable::parameters(*fluent_function).size() < n) {
    yyerror("too many parameters passed to function `"
	    + FunctionTable::name(*fluent_function) + "'");
  } else if (FunctionTable::parameters(*fluent_function).size() > n) {
    yyerror("too few parameters passed to function `"
	    + FunctionTable::name(*fluent_function) + "'");
  }
  const Fluent& fluent = Fluent::make(*fluent_function, term_parameters);
  fluent_function = 0;
  return &fluent;
}


/* Creates a subtraction. */
static const Expression* make_subtraction(const Expression& term,
					  const Expression* opt_term) {
  if (opt_term != 0) {
    return &Subtraction::make(term, *opt_term);
  } else {
    return &Subtraction::make(*new Value(0), term);
  }
}


/* Creates an atom or fluent for the given name to be used in an
   equality formula. */
static void make_eq_name(const std::string* name) {
  const Function* f = domain->functions().find_function(*name);
  if (f != 0) {
    prepare_fluent(name);
    eq_expr = make_fluent();
  } else {
    /* Assume this is a term. */
    eq_term = make_term(name);
    eq_expr = 0;
  }
}


/* Creates an equality formula. */
static const StateFormula* make_equality() {
  if (!requirements->equality) {
    yywarning("assuming `:equality' requirement");
    requirements->equality = true;
  }
  if (first_eq_expr != 0 && eq_expr != 0) {
    return &EqualTo::make(*first_eq_expr, *eq_expr);
  } else if (first_eq_expr == 0 && eq_expr == 0) {
    if (TypeTable::subtype(TermTable::type(first_eq_term),
			   TermTable::type(eq_term))
	|| TypeTable::subtype(TermTable::type(eq_term),
			      TermTable::type(first_eq_term))) {
      return &Equality::make(first_eq_term, eq_term);
    } else {
      return &StateFormula::FALSE;
    }
  } else {
    yyerror("comparison of term and numeric expression");
    return &StateFormula::FALSE;
  }
}


/* Creates a negated formula. */
static const StateFormula* make_negation(const StateFormula& negand) {
  if (typeid(negand) == typeid(Atom)) {
    if (!requirements->negative_preconditions) {
      yywarning("assuming `:negative-preconditions' requirement");
      requirements->negative_preconditions = true;
    }
  } else if (typeid(negand) != typeid(Equality)
	     && dynamic_cast<const Comparison*>(&negand) != 0) {
    require_disjunction();
  }
  return &Negation::make(negand);
}


/* Creates an implication. */
static const StateFormula* make_implication(const StateFormula& f1,
					    const StateFormula& f2) {
  require_disjunction();
  return &(Negation::make(f1) || f2);
}


/* Prepares for the parsing of an existentially quantified formula. */
static void prepare_exists() {
  if (!requirements->existential_preconditions) {
    yywarning("assuming `:existential-preconditions' requirement");
    requirements->existential_preconditions = true;
  }
  context.push_frame();
  quantified.push_back(Term(0));
}


/* Prepares for the parsing of a universally quantified formula. */
static void prepare_forall() {
  if (!requirements->universal_preconditions) {
    yywarning("assuming `:universal-preconditions' requirement");
    requirements->universal_preconditions = true;
  }
  context.push_frame();
  quantified.push_back(Term(0));
}


/* Creates an existentially quantified formula. */
static const StateFormula* make_exists(const StateFormula& body) {
  context.pop_frame();
  size_t m = quantified.size() - 1;
  size_t n = m;
  while (quantified[n].variable()) {
    n--;
  }
  if (n < m) {
    VariableList parameters;
    for (size_t i = n + 1; i <= m; i++) {
      parameters.push_back(quantified[i].as_variable());
    }
    quantified.resize(n, Term(0));
    return &Exists::make(parameters, body);
  } else {
    quantified.pop_back();
    return &body;
  }
}


/* Creates a universally quantified formula. */
static const StateFormula* make_forall(const StateFormula& body) {
  context.pop_frame();
  size_t m = quantified.size() - 1;
  size_t n = m;
  while (quantified[n].variable()) {
    n--;
  }
  if (n < m) {
    VariableList parameters;
    for (size_t i = n + 1; i <= m; i++) {
      parameters.push_back(quantified[i].as_variable());
    }
    quantified.resize(n, Term(0));
    return &Forall::make(parameters, body);
  } else {
    quantified.pop_back();
    return &body;
  }
}


/* Adds a reward rate to the current problem. */
static void add_reward_rate(const StateFormula& condition,
			    const Rational* reward) {
  if (!requirements->rewards) {
    yyerror("reward rates only allowed with the `:rewards' requirement");
  } else {
    FunctionTable::make_dynamic(reward_function);
    problem->add_reward_rate(condition, *reward);
  }
  delete reward;
}

/* Sets the goal reward for the current problem. */
static void set_goal_reward(const Expression& goal_reward) {
  if (!requirements->rewards) {
    yyerror("goal reward only allowed with the `:rewards' requirement");
  } else {
    FunctionTable::make_dynamic(reward_function);
    const Fluent& reward_fluent = Fluent::make(reward_function, TermList());
    problem->set_goal_reward(*new Increase(reward_fluent, goal_reward));
  }
}


/* Sets the default metric for the current problem. */
static void set_default_metric() {
  if (requirements->rewards) {
    problem->set_metric(Fluent::make(reward_function, TermList()));
  } else if (requirements->probabilistic_effects) {
    problem->set_metric(Fluent::make(domain->goal_achieved(), TermList()));
  } else {
    problem->set_metric(Fluent::make(domain->total_time(), TermList()), true);
  }
}
